<template>
  <cabinet-layout nav-active="price">
    <div
      slot="block-content"
      class="priceUpload">
      <submenu
        menu-active="price-upload"
        item-active="upload"/>

      <!--Выводить блок когда еще нет ни одной загрузки-->
      <div
        v-if="!hasUpload && !isNewUpload"
        class="priceUpload-content">
        <div class="heading _h1">Автозагрузка прайс-листов</div>
        <div class="priceUpload-info">
          <div class="priceUpload-info-text">Вы пока не создали ни одного прайс листа</div>
          <AppButton
            :classes="['buttonNewUpload']"
            @click.native="createNewUpload()">
            <template #button-item>
              <img
                svg-inline
                src="~/assets/svg/redesign/plus.svg">
              Создать загрузку
            </template>
          </AppButton>
          <div class="paragraph">
            Шаблоны помогут вам загружать любые прайсы в едином формате, а нам - корректно показывать их вашим
            покупателям.
          </div>
          <div class="paragraph">
            Вы можете создавать отдельные шаблоны, например, для оптовых и розничных прайсов, по производителям и т.д.
          </div>
        </div>
      </div>

      <ComplexHeaderTable
        :table-headings="headingsExample"
        :grid="grid"/>

      <!--Выводить блок с таблицей, когда есть загрузки-->
      <div
        v-if="hasUpload && !isNewUpload"
        class="priceUpload-content">
        <div class="heading _h1">Автозагрузка прайс-листов</div>
        <div class="priceUpload-table">
          <div class="priceUpload-table-header">
            <AppButton
              :classes="['buttonNewUpload']"
              @click.native="createNewUpload()">
              <template #button-item>
                <img
                  svg-inline
                  src="~/assets/svg/redesign/plus.svg">
                Создать новую загрузку
              </template>
            </AppButton>
            <AppInputRadio
              class="_typeUpload"
              name="typeUpload"
              :value="0"
              :list="[
                {label:'Автозагрузка', value:0,},
                {label:'Ручная загрузка', value:1,},
                {label:'Поштучная загрузка', value:2,}]"/>
          </div>

          <AppTable
            class="tablePriceUpload"
            :table-headings="$options.headings"
            :grid="grid">
            <!-- Ячейки с данными для таблицы -->

            <template
              :slot="`unit-${$options.headings[0].name}`"
              slot-scope="{ part }">
              {{ part.id }}
            </template>
            <template
              :slot="`unit-${$options.headings[1].name}`"
              slot-scope="{ part }">
              01.07.2019
            </template>
            <template
              :slot="`unit-${$options.headings[2].name}`"
              slot-scope="{ part }">
              WarehouseProAuto (под заказ из ОАЭ) 23.10.2018).xlsx
            </template>
            <template
              :slot="`unit-${$options.headings[3].name}`"
              slot-scope="{ part }">
              Шаблон 12.08
            </template>
            <template
              :slot="`unit-${$options.headings[4].name}`"
              slot-scope="{ part }">
              Внешняя ссылка
            </template>
            <template
              :slot="`unit-${$options.headings[5].name}`"
              slot-scope="{ part }">
              Новые
            </template>
            <template
              :slot="`unit-${$options.headings[6].name}`"
              slot-scope="{ part }">
              <flink
                href="#"
                class="link">
                ftp://gisauto.ru/eb76feeec8190eda499452a97da9c182
              </flink>
            </template>
            <template
              :slot="`unit-${$options.headings[7].name}`"
              slot-scope="{ part }">
              <button
                class="buttonIcon"
                v-tooltip="{
                  classes: 'tooltipWhite tooltipPriceAction',
                  trigger: 'hover',
                  offset: '12',
                  placement: 'top-end',
                  content: 'Редактировать',}">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/price-edit.svg">
              </button>
              <button
                class="buttonIcon"
                v-tooltip="{
                  classes: 'tooltipWhite tooltipPriceAction',
                  trigger: 'hover',
                  offset: '12',
                  placement: 'top-end',
                  content: 'Копировать',}">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/price-copy.svg">
              </button>
              <AppPopover
                :options="{
                  placement: 'bottom-end',
                  offset: '8',
                  trigger: 'click',
                  additionalClasses: ['tooltipButtonBack', 'tooltipWhite']}">
                <template slot="tooltip-trigger">
                  <button
                    class="buttonIcon"
                    v-tooltip="{
                      classes: 'tooltipWhite tooltipPriceAction',
                      trigger: 'hover',
                      offset: '12',
                      placement: 'top-end',
                      content: 'Удалить',}">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/price-delete.svg">
                  </button>
                </template>
                <div
                  class="tooltip-content"
                  slot="tooltip-content">
                  <div class="tooltip-text">Удалить шаблон?</div>
                  <button
                    class="button _blue"
                    v-close-popover>Нет</button>
                  <button
                    class="button buttonOutline"
                    v-close-popover>Да</button>
                </div>
              </AppPopover>
            </template>
          </AppTable>
        </div>
      </div>

      <!--Выводить блок, когда вызвана новая загрузка-->
      <div
        v-if="isNewUpload"
        class="priceUpload-content">
        <div class="priceUpload-back">
          <AppPopover
            :options="{
              placement: 'right',
              offset: '16',
              trigger: 'click',
              additionalClasses: ['tooltipButtonBack', 'tooltipWhite']}">
            <template slot="tooltip-trigger">
              <button
                class="buttonBack">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/button-arrow-right.svg">
                <span class="link">Вернуться к списку прайс-листов</span>
              </button>
            </template>
            <div
              class="tooltip-content"
              slot="tooltip-content">
              <div class="tooltip-text">Сохранить изменения?</div>
              <button
                class="button _blue"
                @click="closeFormUpload()"
                v-close-popover>Да</button>
              <button
                class="button buttonOutline"
                @click="closeFormUpload()"
                v-close-popover>Нет</button>
            </div>
          </AppPopover>
        </div>
        <div class="heading _h1">Настройка загрузки запчастей</div>
        <div class="priceUpload-settings">
          <div class="uploadType">
            <div class="uploadType-item">
              <div class="priceLabel">Загрузить файл</div>
              <AppInputRadio
                class="_fileUploadType"
                name="fileUploadType"
                :value="currentUploadType"
                @input="changeUploadType($event, currentUploadType)"
                :list="[
                  {label:'С компьютера', value:$options.fileUploadType.PC,},
                  {label:'По почте', value:$options.fileUploadType.EMAIL,},
                  {label:'По внешней ссылке', value:$options.fileUploadType.HREF,},
                  {label:'По FTP', value:$options.fileUploadType.FTP,},
                  {label:'Из 1C', value:$options.fileUploadType.S1,}]"/>
            </div>
            <div class="uploadType-item">
              <span>или</span>
              <AppButton
                :classes="[ 'buttonOutline', 'buttonAddOne' ]"
                :class="{ '_selected': currentUploadType===$options.fileUploadType.PIECE }"
                @click.native="changeUploadType($options.fileUploadType.PIECE)">
                <span slot="button-item">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/plus.svg">
                  Добавить запчасти поштучно
                </span>
              </AppButton>
            </div>
          </div>
          <div class="priceUpload-subtitle heading _h2">{{ subtitle }}</div>

          <FormAutoUpload :upload-type="currentUploadType"/>

        </div>
      </div>
    </div>
  </cabinet-layout>
</template>

<script>
import CabinetLayout from '~/components/redesign/cabinet/main-layout';
import Submenu from '~/components/redesign/cabinet/submenu';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputRadio from '~/components/redesign/app-input/app-input-radio';
import AppTable from '~/components/redesign/app-table/app-table';
import FormAutoUpload from '~/components/redesign/cabinet/price-upload/form-auto-upload';

import { priceUpload as Headings } from '~/assets/js/mocks/table/headings';
import FileUploadType from '~/assets/js/enums/price-upload/file-upload-type';
import AppPopover from '../../../../../components/redesign/app-tooltip/app-popover';
import ComplexHeaderTable from '../../../../../components/redesign/app-table/complex-header-table';

export default {
  name: 'PriceUpload',
  components: {
    ComplexHeaderTable,
    AppPopover,
    AppTable,
    AppInputRadio,
    AppButton,
    CabinetLayout,
    Submenu,
    FormAutoUpload,
  },
  layout: 'cabinet',
  data() {
    return {
      hasUpload: true,
      isNewUpload: false,
      currentUploadType: 'pc',
      grid: {
        data: [
          {
            id: 0,
            data: '10.10.2020',
          },
          {
            id: 1,
            data: '10.10.2020',
          },
          {
            id: 2,
            data: '10.10.2020',
          },
        ],
      },
      headingsExample: [
        {
          name: 'number',
          title: '№',
          classes: '',
          sorting: { has: false, criteria: '' },
          filter: { has: false, criteria: '' },
        },
        {
          name: 'example1',
          title: '',
          classes: '',
          sorting: { has: false, criteria: '' },
          filter: { has: true, criteria: '' },
        },
        {
          name: 'example2',
          title: 'example2',
          classes: '',
          sorting: { has: true, criteria: '' },
          filter: { has: false, criteria: '' },
        },
        {
          name: 'example3',
          title: '',
          classes: '',
          sorting: { has: false, criteria: '' },
          filter: { has: true, criteria: '' },
        },
      ],
    };
  },
  computed: {
    subtitle() {
      let title = '';
      switch (this.currentUploadType) {
        case 'pc': title = 'Загрузка прайса со своего компьютера'; break;
        case 'email': title = 'Загрузка прайса по почте'; break;
        case 'href': title = 'Загрузка прайса по внешней ссылке'; break;
        case 'ftp': title = 'Загрузка прайса на FTP ГисАвто'; break;
        case 's1': title = 'Выгрузка прайса из 1С'; break;
        case 'one': title = 'Поштучная загрузка запчастей'; break;
        default: title = '';
      }

      return title;
    },
  },
  created() {
    this.$options.headings = Headings;
    this.$options.fileUploadType = FileUploadType;
  },
  methods: {
    changeUploadType(target) {
      if (!Object.values(FileUploadType).includes(target)) {
        return false;
      }
      this.currentUploadType = target;

      return true;
    },
    createNewUpload() {
      this.isNewUpload = true;
    },
    closeFormUpload() {
      this.isNewUpload = false;
    },
  },
};
</script>

<style lang="postcss">
 @import "~/assets/css/components/price-upload-pages.css";
</style>
